表对象TableAnnotation

如图,在Solidworks工程图中会用到很多表,包括普通的表,明细表等。本文我们先学习普通的表对象TableAnnotation以及表特征GeneralTableFeature的相关使用。

image.png

GeneralTableFeature是表的特征体现,TableAnnotation则是表特征的一个具体的表。本文将通过表的插入,获取等操作,学习表类对象的一些常规使用方法。

示例1 表格的插入

表格的插入主要使用了工程图文档对象的DrawingDoc::InsertTableAnnotation2方法。本例中将插入一个使用模板的表格和一个自定义的表格

实例代码

public static void InsertTable(ModelDoc2 SwDoc,string TempPath)
{
    double x = 600 / 1000.0;
    double y1 = 200 / 1000.0;
    double y2 = 100 / 1000.0;
    
    Sheet SwSheet = ((DrawingDoc)SwDoc).GetCurrentSheet();
    double[] sheetprop = SwSheet.GetProperties2();
    double scale = sheetprop[2] / sheetprop[3];

    //使用表模板
    SwDoc.SketchManager.CreateLine(0,0,0,x*1.0/ scale, y1 * 1.0 / scale, 0);
    TableAnnotation SwTable1=((DrawingDoc)SwDoc).InsertTableAnnotation2(false, x, y1, (int)swBOMConfigurationAnchorType_e.swBOMConfigurationAnchor_TopRight, TempPath, 4, 6);
    SwTable1.Title = "模板表格标题";
    SwTable1.GeneralTableFeature.GetFeature().Name = "示例模板表格";

    //自定义表
    SwDoc.SketchManager.CreateLine(0, 0, 0, x * 1.0 / scale, y2 * 1.0 / scale, 0);
    TableAnnotation SwTable2 = ((DrawingDoc)SwDoc).InsertTableAnnotation2(false, x, y2, (int)swBOMConfigurationAnchorType_e.swBOMConfigurationAnchor_TopLeft,"", 4, 6);
    SwTable2.Title = "自定义表格标题";
    SwTable2.GeneralTableFeature.GetFeature().Name = "示例自定义表格";
    SwTable2.Text2[2, 3,true] = "测试文本";
  }

实例效果

image.png

实例解析

DrawingDoc::InsertTableAnnotation2参数解读

image.png
image.png

从实例的效果图与分析可以看到,决定表格的位置,不仅和参数有关,也与表格的锚点设置类型有关。

通过TableAnnotation实例的属性和方法,我们可以对单元格进行赋值,插入行列等常规表格自动化操作。

实例2 获取表格

本例将通过TableAnnotation,GeneralTableFeature的方法属性,来获取上例中插入的表格及获取相关消息。

代码实例

 public static void GetTable(ModelDoc2 SwDoc,string TableName)
 {
     Feature SwTableFeat = ((DrawingDoc)SwDoc).FeatureByName(TableName);
     if (SwTableFeat != null)
     {
         StringBuilder Sb = new StringBuilder("");
         GeneralTableFeature gtf = SwTableFeat.GetSpecificFeature2();
         TableAnnotation SwTabe = gtf.GetTableAnnotations()[0];
         Sb.Append("表标题:"+SwTabe.Title+"\r\n");
         Sb.Append("内容:" + SwTabe.Text2[2, 3,true]);
         System.Windows.MessageBox.Show(Sb.ToString().Trim());
     }
 }

实例效果

image.png

实例分析

当我们需要获得表格中的信息时,可以通过特征获取方式先获得表特征对象GeneralTableFeature实例,然后通过该特征获得所需要操作的表对象TableAnnotation实例。这里不妨读者先思考下GeneralTableFeature与TableAnnotation的关系。

实例3 表的拆分与合并

在实例2中,我们看到我们需要先获得GeneralTableFeature对象,再间接获得TableAnnotation对象。为什么TableAnnotation不能代表一个特征呢?我们先来看下本实例,本实例对表进行了行拆分和行合并。

实例代码

 public static void SetTable(ModelDoc2 SwDoc, string TableName)
 {
      Feature SwTableFeat = ((DrawingDoc)SwDoc).FeatureByName(TableName);
      if (SwTableFeat != null)
      {
          StringBuilder Sb = new StringBuilder("");
          GeneralTableFeature gtf = SwTableFeat.GetSpecificFeature2();
          TableAnnotation SwTabe = gtf.GetTableAnnotations()[0];

          #region 表格拆分
          System.Windows.MessageBox.Show("分割前表数量:"+ gtf.GetTableAnnotationCount().ToString());
          SwTabe.Split((int)swTableSplitLocations_e.swTableSplit_AfterRow, 1);
          System.Windows.MessageBox.Show("分割后表数量:" + gtf.GetTableAnnotationCount().ToString());
          SwTabe.Merge((int)swTableMergeLocations_e.swTableMerge_All);
          System.Windows.MessageBox.Show("合并后表数量:" + gtf.GetTableAnnotationCount().ToString());
          #endregion
     }
}

实例效果

image.png
image.png

实例分析

从表格拆分后,我们可以很明显地看到,一个表格的特征GeneralTableFeature对应了多个表格TableAnnotation实例。从这里我们可以进一步理解GeneralTableFeature与TableAnnotation的区别。

如下图为本文的示例程序,源码可上我的Github下载。操作步骤可见文章《公众号源码Github分享库》 , 实例序号23

image.png

你可能感兴趣的:(表对象TableAnnotation)